/* stepper controller
 
 * 
 * control stepper motor with poti in half step mode (smoother than full step)
 *
 
 * SensorAktor Workshop
 * Lab3 2008
 * Kunsthochschule fuer Medien Koeln
 * Academy of Media Arts Cologne
 * http://interface.khm.de
 
 * pin mapping SensorAktor Shield (import <SensorAktor.h> to get already defined mapping)
 *
 * analog inputs: a0 = pin0, a1 = pin1, a2 = pin2, a3 = pin3, a4 = pin4, a5 = pin5
 * built-in poti: poti = pin5
 * amplified input: mic = pin0
 * switches: s1 = pin1, s2 = pin2, s3 = pin3
 * leds: led1 = pin3, led2 = pin5, led3 = pin6
 * power outs: out1 = pin3, out2 = pin5, out3 = pin6
 * motor outs: motor1_1 = pin8, motor1_2 = pin13, motor2_1 = pin11, motor2_2 = pin12
 * motor pwms: pwmMotor1 = pin10, pwmMotor2 = pin9
 * servo outs: servo1 = pin2, servo2 = pin4, servo3 = pin7
 
 */

// import sensor aktor library for pin mapping
#include <SensorAktor.h>

// import stepper library
#include <StepperL293.h>
// create instance for stepper
#include "WProgram.h"
void setup();
void loop();
StepperL293 myStepper;

// poti value
int potiValue = 0;

// this block is executed one time when programm starts
void setup(){

  // attach pins to stepper (motor pin1, motor pin2, motor pin3, motor pin4, number of steps of motor)
  myStepper.attach(motor1_1, motor1_2, motor2_1, motor2_2, 48);

  // set mode (0 = half step moede, 1 = full step mode)
  myStepper.setMode(0);

  // set power (value between 0 and 100)
  myStepper.setPower(100);

  // set speed (values between 1 and 100)
  myStepper.setSpeed(50);

}

// this block is executed in a loop after setup is called one time
void loop(){

  // read poti (value between 0 and 1023)
  potiValue = analogRead(poti);

  // set step of stepper using poti value
  myStepper.setStep(potiValue);  

  // drive stepper
  myStepper.drive();

}

int main(void)
{
	init();

	setup();
    
	for (;;)
		loop();
        
	return 0;
}

